function changegrid, newgrid
;
@common
;
;
   if cmpgrid(newgrid) EQ 0 then return, 0
;
; update the common paramaters
;
   ccmeshparameters = newgrid
   jpiglo = newgrid.jpiglo
   jpjglo = newgrid.jpjglo
   jpkglo = newgrid.jpkglo
   jpi = newgrid.jpi
   jpj = newgrid.jpj
   jpk = newgrid.jpk
   ixminmesh = newgrid.ixminmesh
   ixmaxmesh = newgrid.ixmaxmesh
   iyminmesh = newgrid.iyminmesh
   iymaxmesh = newgrid.iymaxmesh
   izminmesh = newgrid.izminmesh
   izmaxmesh = newgrid.izmaxmesh
   key_shift = newgrid.key_shift
   boundary = newgrid.boundary
;
; read the new file
;
   if newgrid.filetype EQ 'batch file' THEN BEGIN 
      createpro, '@'+strmid(newgrid.filename[0], 0, strlen(newgrid.filename)-4) $
          , filename = myuniquetmpdir +'for_createpro.pro'
      return, 1
   ENDIF ELSE BEGIN 
      readmesh, newgrid.filename, newgrid.filetype, glamboundary = boundary
   ENDELSE
;
;
   key_periodic = newgrid.key_periodic
;   
   @updateold
   domdef
   if newgrid.triangulation EQ 1 then triangles_list = triangule() $
   ELSE triangles_list = -1
;
  IF NOT keyword_set(key_forgetold) THEN BEGIN
   @updateold
  ENDIF
;
   return, 1
end
