;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; NAME:vraizoom
;
; PURPOSE:fait un vari zoom dans un plot, contrairement a la fonction
; ZOOM  preecrite par IDL qui ne fait que grossir les pixels
;
; CATEGORY:petit outil
;
; CALLING SEQUENCE:@vzoom
;
; SIDE EFFECTS:utilise le journal. 
;
; RESTRICTIONS:
;
; EXAMPLE:
;
; MODIFICATION HISTORY: Sebastien Masson (smasson@lodyc.jussieu.fr)
;                       29/4/1999
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
   cursor, x1, y1, /data, /dowm
   cursor, x2, y2, /data, /down
   x = [x1, x2]
   x = x[sort(x)]
   y = [y1, y2]
   y = y[sort(y)]
   domdef, [x, y, vert1, vert2]
; il faut fermer le journal!
   journal
; on recupere le journal sous la forme d''un vecteur de string:
   vectjournal = getfile(myuniquetmpdir+'idlsave.pro')
; on coupe la derniere ligne qui est vraizoom
   vectjournal = vectjournal[0:n_elements(vectjournal)-2 ]
;------------------------------------------------------------
; on le corrige si besoin est...
;------------------------------------------------------------
for i = 0, n_elements(vectjournal)-1 do $
 if strpos(vectjournal[i],'text_box' ) EQ -1 then $
 vectjournal[i] = strtrim(strcompress(vectjournal[i]), 2)
;2 lignes sont identiques ??
for i = 0, n_elements(vectjournal)-2 do $
 if vectjournal[i] EQ vectjournal[i+1] then vectjournal[i] = ' '

for i = 0, n_elements(vectjournal)-1 do BEGIN & $
 if strpos(vectjournal[i],'oups' ) NE -1 $
 OR strpos(vectjournal[i],'Syntax error' ) NE -1 $
 OR strpos(vectjournal[i],'Illegal character' ) NE -1 $
 then BEGIN vectjournal[i] = ' ' & vectjournal[i-1] = ' ' & endif & $
 if strpos(strtrim(vectjournal[i], 1),'retall' ) EQ 0 $
 OR strpos(vectjournal[i],'@ps' ) NE -1 $
 OR strpos(vectjournal[i],'@oups' ) NE -1 $
 OR strpos(vectjournal[i],'@vzoom' ) NE -1 $
 OR strpos(vectjournal[i],'help' ) NE -1 $
 OR strpos(vectjournal[i],'print' ) NE -1 $
 then  vectjournal[i] = ' ' & $
 if strpos(vectjournal[i],'text_box' ) NE -1 then $
 IF strpos(vectjournal[i],',pos=' ) EQ -1 then $
 vectjournal[i] = vectjournal[i]+strmid(vectjournal[i+1], 1) & endfor


;
; on reecrit idlsave.pro
putfile, myuniquetmpdir+'idlsave.pro', vectjournal
; applique idlsave
   cd,  current = curdir
   cd, myuniquetmpdir
@idlsave   
   cd, curdir
; le journal vient d'etre reouvert, et on y met les elements de
; vectjournal 
for i = 0, n_elements(vectjournal)-1 DO $
journal, vectjournal[i]



